#ifndef __winExeOpe_h__
#define __winExeOpe_h__

#include "winExeCom.h"
int addFun(tokenData r1, tokenData r2){				// ** Z
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC){r.v.INT=r1.v.INT+r2.v.INT;}
	else if(r1.type==FLT || r2.type==FLT){
		r.type=FLT;	r.v.DBL=(double)(doubleX(r1)+doubleX(r2));
	}
	return exePush(r);
}

int subFun(tokenData r1, tokenData r2){				// ** Z
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC){r.v.INT=r1.v.INT-r2.v.INT;}
	else if(r1.type==FLT || r2.type==FLT){
			r.type=FLT;	r.v.DBL=(double)(doubleX(r1)-doubleX(r2));
	}
	return exePush(r);
}
int mltFun(tokenData r1, tokenData r2){				// ** Z
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC){r.v.INT=r1.v.INT*r2.v.INT;}
	else if(r1.type==FLT || r2.type==FLT){
		r.type=FLT; r.v.DBL=(double)(doubleX(r1)*doubleX(r2));
	}
	return exePush(r);
}
int divFun(tokenData r1, tokenData r2){				// ** Z
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC){r.v.INT=r1.v.INT/r2.v.INT;}
	else if(r1.type==FLT || r2.type==FLT){
		r.type=FLT; r.v.DBL=(double)(doubleX(r1)/doubleX(r2));
	}
	return exePush(r);
}
int modFun(tokenData r1, tokenData r2){				// ** ]
	tokenData r=r1;r.type=DEC; r.v.INT=intX(r1) % intX(r2);	return exePush(r);
}
tokenData toString(tokenData r);// ϊvg^Cv錾
int conFun(tokenData r1, tokenData r2){				// ** A
	 tokenData x1=toString(r1);	 tokenData x2=toString(r2);
	 int L1=lstrlen(x1.str),L2=lstrlen(x2.str);
	 tokenData r; r.type=STR; r.v.INT=L1+L2;
	 if(r.v.INT==0) r.str=NULL;
	 else           r.str = (TCHAR *)calloc(r.v.INT+1, sizeof(TCHAR));
 	if(r.str!=NULL) {
		if(x1.str !=NULL) for(int i=0;i<L1;i++) r.str[i]   =x1.str[i];
		if(x2.str !=NULL) for(int i=0;i<L2;i++) r.str[L1+i]=x2.str[i];
		r.str[r.v.INT]=0;
	}
	return exePush(r);
}
int eqFun(tokenData r1, tokenData r2){				// ** l
	int RR=0;
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT==r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL==r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)==doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)==0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
int neFun(tokenData r1, tokenData r2){				// ** 񓯒l
	int RR=1;//rs\̂Ƃ񓯒lƂ݂ȂB
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT!=r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL!=r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)!=doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)!=0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
int gtFun(tokenData r1, tokenData r2){				// ** Greater than
	int RR=0;
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT>r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL>r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)>doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)>0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
int geFun(tokenData r1, tokenData r2){				// ** Greater than equal
	int RR=0;
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT>=r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL>=r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)>=doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)>=0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
int ltFun(tokenData r1, tokenData r2){				// ** Less thanl
	int RR=0;
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT<r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL<r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)<doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)<0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
int leFun(tokenData r1, tokenData r2){				// ** Less than equal
	int RR=0;
	if(r1.type==DEC && r2.type==DEC) RR=(r1.v.INT<=r2.v.INT);
    else if(r1.type==FLT && r2.type==FLT) RR=(r1.v.DBL<=r2.v.DBL);
    else if(r1.type==FLT || r2.type==FLT) RR=(doubleX(r1)<=doubleX(r2));
    else if(r1.type==STR && r2.type==STR) RR=(lstrcmp(r1.str,r2.str)<=0);
	tokenData x; x.type=DEC;x.v.INT=RR; x.str=NULL;
	return exePush(x);
}
tokenData logShift(tokenData r1,tokenData r2){//Ř_VtgꍇÅ֐gB
	int X=intX(r2); unsigned int Y=(unsigned int)intX(r2);
	if(X>0) Y<<=X; else Y>>=(- X);//̂ƂVtgÂƂEVtg
	tokenData r;r.type=DEC;r.v.INT=(int)Y;return r;
}
int leftShift(tokenData r1,tokenData r2){//@** Vtg
	int X=intX(r2);tokenData r=r1;unsigned int S[2];
	if     (r.type==DEC) r.v.INT=r.v.INT << X;//̏ꍇZpVtgAdoublȅꍇ_Vtg
	else if(r.type==FLT) { S[0]=r.v.INA[0]; S[1]=r.v.INA[1];  leftShiftDbl(r.v.INA,S, X);}
	return exePush(r);
}
int rightShift(tokenData r1,tokenData r2){//  *** EVtg
	int X=intX(r2);tokenData r=r1;unsigned int S[2];
	if     (r.type==DEC) r.v.INT=r.v.INT >> X;//̏ꍇZpVtgAdoublȅꍇ_Vtg
	else if(r.type==FLT) { S[0]=r.v.INA[0]; S[1]=r.v.INA[1];  rightShiftDbl(r.v.INA,S, X);}
	return exePush(r);
}
int andFun(tokenData r1, tokenData r2){				// ** _ρiAndj
	tokenData x; x.type=DEC;x.v.INT=0; x.str=NULL;
	if(r1.type==DEC && r2.type==DEC) x.v.INT=(r1.v.INT && r2.v.INT);
	if(r1.type==DEC && r2.type==DEC) x.v.INT=(r1.v.INT && r2.v.INT);
    return exePush(x);
}
int orFun(tokenData r1, tokenData r2){				// ** _aiOrj
	tokenData x; x.type=DEC;x.v.INT=0; x.str=NULL;
	if(r1.type==DEC && r2.type==DEC) x.v.INT=(r1.v.INT || r2.v.INT);
    return exePush(x);
}
int bitAndFun(tokenData r1,tokenData r2){
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC )      {r.v.INT=r1.v.INT & r2.v.INT;} 
	else if(r1.type==FLT && r2.type==FLT ) {
		r.v.INA[0]=r1.v.INA[0] & r2.v.INA[0]; r.v.INA[1]=r1.v.INA[1] & r2.v.INA[1]; 
	}
	return exePush(r);
	
}
int bitOrFun(tokenData r1,tokenData r2){
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC )      {r.v.INT=r1.v.INT | r2.v.INT;} 
	else if(r1.type==FLT && r2.type==FLT ) {
		r.v.INA[0]=r1.v.INA[0] | r2.v.INA[0]; r.v.INA[1]=r1.v.INA[1] | r2.v.INA[1]; 
	}
	return exePush(r);
	
}
int bitExorFun(tokenData r1,tokenData r2){
	tokenData r=r1;
	if(r1.type==DEC && r2.type==DEC )      {r.v.INT=r1.v.INT ^ r2.v.INT;} 
	else if(r1.type==FLT && r2.type==FLT ) {
		r.v.INA[0]=r1.v.INA[0] ^ r2.v.INA[0]; r.v.INA[1]=r1.v.INA[1] ^ r2.v.INA[1]; 
	}
	return exePush(r);
	
}
int asignFun(tokenData r1,tokenData r2){			// ** (=)
	tokenData r=r1; tokenData s=evalDT(r2);
	if(r.type==NAM){
		int i; i=NameTableSearch(NameTab[r.v.INT].Name);
		while(NameTab[i].DT.type==NAM)i=NameTab[i].DT.v.INT;
		if(NameTab[i].DT.type==ADR)(*NameTab[i].DT.addr)=s;
		else NameTab[i].DT=s;
	}
	else if(r.type==ADR)(*r.addr)=s; 
	else {exePush(s); return 501;}
	return exePush(s);
}
int asignAddFun(tokenData r1,tokenData r2){			// ** (+=)
	tokenData r=r1;tokenData s=evalDT(r); addFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignSubFun(tokenData r1,tokenData r2){			// ** (-=)
	tokenData r=r1;tokenData s=evalDT(r); subFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignMltFun(tokenData r1,tokenData r2){			// ** (*=)
	tokenData r=r1;tokenData s=evalDT(r); mltFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignDivFun(tokenData r1,tokenData r2){			// ** (/=)
	tokenData r=r1;tokenData s=evalDT(r); divFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignModFun(tokenData r1,tokenData r2){			// ** (%=)
	tokenData r=r1;tokenData s=evalDT(r); modFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignLeftShift(tokenData r1,tokenData r2){			// ** (<<=)
	tokenData r=r1;tokenData s=evalDT(r); leftShift(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignRightShift(tokenData r1,tokenData r2){			// ** (>>=)
	tokenData r=r1;tokenData s=evalDT(r); rightShift(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignBitAnd(tokenData r1,tokenData r2){			   // ** (&=)
	tokenData r=r1;tokenData s=evalDT(r); bitAndFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignBitOr(tokenData r1,tokenData r2){			   // ** (|=)
	tokenData r=r1;tokenData s=evalDT(r); bitOrFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}
int asignBitExor(tokenData r1,tokenData r2){			   // ** (^=)
	tokenData r=r1;tokenData s=evalDT(r); bitExorFun(s,r2); tokenData s2=exePop();
	return asignFun(r,s2);
}

int plusFun(tokenData r){return exePush(r);}		// ** PZq́{
int minusFun(tokenData r){							// ** PZq́|
	tokenData rr=r;
	if(r.type==DEC) rr.v.INT=-r.v.INT;
	else if(r.type==FLT)rr.v.DBL=-r.v.DBL;
	return exePush(rr);
}
int notFun(tokenData r){							// ** _ے(not)
	tokenData x;x.type=DEC;x.v.INT=0;x.str=NULL;
	if(r.type==DEC) x.v.INT= !r.v.INT;
	return exePush(x);
}
int bitNotFun(tokenData dt){						// ** rbg]
    tokenData r=dt;
	if(r.type==DEC) r.v.INT = ~r.v.INT;
	if(r.type==FLT) {r.v.INA[0]= ~r.v.INA[0];r.v.INA[1]= ~r.v.INA[1];}
	return exePush(r);
}
int incAFun(tokenData r1){							// ** uZq{{
    tokenData r2; r2.type=DEC; r2.v.INT=1; tokenData r=r1;tokenData s=evalDT(r);
	if(exePush(s)) return 1; if(addFun(s,r2)) return 1;	r2=exePop(); 
	if(asignFun(r,r2)) return 1; r2=exePop();return 0;
}
int incBFun(tokenData r1){							// ** OuZq{{
	tokenData r2; r2.type=DEC; r2.v.INT=1; tokenData r=r1;tokenData s=evalDT(r);
	if(addFun(s,r2)) return 1; r2=exePop();	if(asignFun(r, r2)) return 1;
	return 0;
}
int decAFun(tokenData r1){							// ** uZq{{
	tokenData r2; r2.type=DEC; r2.v.INT=-1; tokenData r=r1;tokenData s=evalDT(r);
	if(exePush(s)) return 1; if(addFun(s,r2)) return 1;	r2=exePop(); 
	if(asignFun(r,r2)) return 1; r2=exePop();return 0;
}
int decBFun(tokenData r1){							// ** OuZq||
	tokenData r2; r2.type=DEC; r2.v.INT=-1; tokenData r=r1;tokenData s=evalDT(r);
	if(addFun(s,r2)) return 1; r2=exePop();	if(asignFun(r, r2)) return 1;
	return 0;
}
int exeST(){// ** Jn
	tokenData r=exePop();ptrExeStack=BeforStackP;
	int errcode;if((errcode=exePush(DlmData(TEXT("*ST"))))!=0) return errcode;
	return 0;
}					
int exeJP(){											// ** Jump
	tokenData r=evalPop();if(r.type!=DEC)return 500;
	pCounter=r.v.INT;return 0;
}
int exeJZ(){											// ** X^bN0̂ƂJump
	tokenData r2=evalPop();if(r2.type!=DEC)return 500;
	tokenData r1=evalPop();if(r1.type!=DEC)return 500;
	if(r1.v.INT==0) pCounter=r2.v.INT; 
	return 0;
}
int exeJN(){											// ** X^bN0łȂƂJump
	tokenData r2=evalPop();if(r2.type!=DEC)return 500;
	tokenData r1=evalPop();if(r1.type!=DEC)return 500;
	if(r1.v.INT!=0) pCounter=r2.v.INT; 
	return 0;
}
#endif